clear variables
close all

% Table 4.1 - Descriptive Statistics
load ./Replication_IntermediateData/data_temp_sumstats_64
% Summary Stats:
temp_deduc = [ mean(dd_coll) ];
temp_pricing = [mean(pp_coll(:,4)) std(pp_coll(:,4)) prctile(pp_coll(:,4),5) prctile(pp_coll(:,4),50) prctile(pp_coll(:,4),95)];
temp_price_change1 = abs(pp_coll(:,4)-pp_coll(:,3));
temp_price_change2 = abs(pp_coll(:,4)-pp_coll(:,5));
temp_pricing = [temp_pricing; ...
                mean(temp_price_change1) std(temp_price_change1) prctile(temp_price_change1,5) prctile(temp_price_change1,50) prctile(temp_price_change1,95); ...
                mean(temp_price_change2) std(temp_price_change2) prctile(temp_price_change2,5) prctile(temp_price_change2,50) prctile(temp_price_change2,95)];
temp_lambda = [ mean(lambda_coll) std(lambda_coll) prctile(lambda_coll,5) prctile(lambda_coll,50) prctile(lambda_coll,95)] ;
temp_demographics = [ mean(female1)  std(female1)  prctile(female1,5)  prctile(female1,50)  prctile(female1,95) ; ...
                      mean(drv_age1) std(drv_age1) prctile(drv_age1,5) prctile(drv_age1,50) prctile(drv_age1,95) ; ...
                      mean(peter)    std(peter)    prctile(peter,5)    prctile(peter,50)    prctile(peter,95) ] ;
temp_ded_dollars = [mean(dd_coll*deduc_list_coll') std(dd_coll*deduc_list_coll') prctile(dd_coll*deduc_list_coll',5) prctile(dd_coll*deduc_list_coll',50) prctile(dd_coll*deduc_list_coll',95)];              
% Sample size for groups
length(lambda_coll)
sum(female1==0)
sum(female1==1)
sum(indicator_young)
sum(indicator_old)
sum(indicator_low)
sum(indicator_high)
mean(dd_coll)*100
mean(dd_coll(female1==0,:))*100
mean(dd_coll(female1==1,:))*100
mean(dd_coll(indicator_young==1,:))*100
mean(dd_coll(indicator_old==1,:))*100
mean(dd_coll(indicator_low==1,:))*100
mean(dd_coll(indicator_high==1,:))*100

% Figure 5.1 - AS 95 confidence sets on mean and var
% Use Replication_Main_03b.m

load '.\Replication_Results\AS_grid_all_64_2.mat'
theta_AS_64       = theta_pass;

% Table 5.1 - Distribution of Absolute Risk Aversion
rp_prob = .1;
rp_loss = 1000;
quantiles_p = [.25 .75]; 
load .\Replication_Results\KMS_CI_all_64_2_3_1
theta_KMS_meanmax = theta_pass_KMS;
mean_UB = max(mean_KMS_pass)
load .\Replication_Results\KMS_CI_all_64_2_3_0
theta_KMS_meanmin = theta_pass_KMS;
mean_LB = min(mean_KMS_pass)

Y_inv_AS_64 = zeros(size(theta_AS_64,1),length(quantiles_p));
for ii=1:size(theta_AS_64,1)
   theta_temp = theta_AS_64(ii,:);
   Y_inv_AS_64(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));  
end
beta_invY_BCMT = r_bar*Y_inv_AS_64;

mean_bmot = .00113;
mean_ce = .00310;

load .\Replication_Results\comparator_ASR_full_2_and_above
theta_ASR    = param_coll(1:2);
load .\Replication_Results\comparator_UR_full_2_and_above
theta_UR    = param_coll(1:2);
mean_UR     = r_bar.*theta_UR(1)./(theta_UR(1)+theta_UR(2));
var_UR      = r_bar^2.*theta_UR(1).*theta_UR(2)./((theta_UR(1)+theta_UR(2)).^2.*(theta_UR(1)+theta_UR(2)+1));
mean_ASR    = r_bar.*theta_ASR(1)./(theta_ASR(1)+theta_ASR(2));
var_ASR     = r_bar^2.*theta_ASR(1).*theta_ASR(2)./((theta_ASR(1)+theta_ASR(2)).^2.*(theta_ASR(1)+theta_ASR(2)+1));

beta_invY_UR        = r_bar*betainv(quantiles_p,theta_UR(1),theta_UR(2));  
beta_invY_ASR       = r_bar*betainv(quantiles_p,theta_ASR(1),theta_ASR(2));  

% Bootstrap
load '.\Replication_Results\comparator_UR_full_2_and_above_boot.mat'
mean_UR_CI = [prctile(mean_boot,5) prctile(mean_boot,95)];
var_UR_CI = [prctile(var_boot,5) prctile(var_boot,95)];
p25_UR_CI = [prctile(beta_invY_UR_boot(:,1),5) prctile(beta_invY_UR_boot(:,1),95)];
p75_UR_CI = [prctile(beta_invY_UR_boot(:,2),5) prctile(beta_invY_UR_boot(:,2),95)];
load '.\Replication_Results\comparator_ASR_full_2_and_above_boot.mat'
mean_ASR_CI = [prctile(mean_boot,5) prctile(mean_boot,95)];
var_ASR_CI = [prctile(var_boot,5) prctile(var_boot,95)];
p25_ASR_CI = [prctile(beta_invY_ASR_boot(:,1),5) prctile(beta_invY_ASR_boot(:,1),95)];
p75_ASR_CI = [prctile(beta_invY_ASR_boot(:,2),5) prctile(beta_invY_ASR_boot(:,2),95)];

bmot_rp_mean    = (1/mean_bmot)*log((1-rp_prob)+rp_prob*exp(rp_loss*mean_bmot))-(rp_prob*rp_loss)
ce_rp_meanb     = (1/mean_ce  )*log((1-rp_prob)+rp_prob*exp(rp_loss*mean_ce  ))-(rp_prob*rp_loss)

main_ra = [mean_LB min(beta_invY_BCMT(:,1)) min(beta_invY_BCMT(:,2)); mean_UB max(beta_invY_BCMT(:,1)) max(beta_invY_BCMT(:,2))];
ur_ra   = [mean_UR_CI p25_UR_CI p75_UR_CI];
asr_ra  = [mean_ASR_CI p25_ASR_CI p75_ASR_CI];

main_rp = (1./main_ra).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*main_ra))-(rp_prob.*rp_loss)
ur_rp   = (1./ur_ra).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*ur_ra))-(rp_prob.*rp_loss)
asr_rp  = (1./asr_ra).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*asr_ra))-(rp_prob.*rp_loss)


% Table 5.2 - Distribtuion of Choice Set Size
load .\Replication_Results\KMS_CI_all_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_all_64_3_11_1
max(theta_pass_KMS)


% Table S3.1 - Deductible Chices by Octiles
load ./Replication_IntermediateData/data_temp_all_64
bin_index = zeros(size(individ_data(:,1)));
dd_coll = individ_data(:,2:6);
for ii=1:size(individ_data,1)
   bin_index(ii) = map_type_bin(map_type_bin(:,1)==individ_data(ii,1),2);
end
table = [mean(dd_coll(bin_index==1,:)); ...
mean(dd_coll(bin_index==2,:)); ...
mean(dd_coll(bin_index==3,:)); ...
mean(dd_coll(bin_index==4,:)); ...
mean(dd_coll(bin_index==5,:)); ...
mean(dd_coll(bin_index==6,:)); ...
mean(dd_coll(bin_index==7,:)); ...
mean(dd_coll(bin_index==8,:)); ...
mean(dd_coll(bin_index==9,:)); ...
mean(dd_coll(bin_index==10,:)); ...
mean(dd_coll(bin_index==11,:)); ...
mean(dd_coll(bin_index==12,:)); ...
mean(dd_coll(bin_index==13,:)); ...
mean(dd_coll(bin_index==14,:)); ...
mean(dd_coll(bin_index==15,:)); ...
mean(dd_coll(bin_index==16,:)); ...
mean(dd_coll(bin_index==17,:)); ...
mean(dd_coll(bin_index==18,:)); ...
mean(dd_coll(bin_index==19,:)); ...
mean(dd_coll(bin_index==20,:)); ...
mean(dd_coll(bin_index==21,:)); ...
mean(dd_coll(bin_index==22,:)); ...
mean(dd_coll(bin_index==23,:)); ...
mean(dd_coll(bin_index==24,:)); ...
mean(dd_coll(bin_index==25,:)); ...
mean(dd_coll(bin_index==26,:)); ...
mean(dd_coll(bin_index==27,:)); ...
mean(dd_coll(bin_index==28,:)); ...
mean(dd_coll(bin_index==29,:)); ...
mean(dd_coll(bin_index==30,:)); ...
mean(dd_coll(bin_index==31,:)); ...
mean(dd_coll(bin_index==32,:)); ...
mean(dd_coll(bin_index==33,:)); ...
mean(dd_coll(bin_index==34,:)); ...
mean(dd_coll(bin_index==35,:)); ...
mean(dd_coll(bin_index==36,:)); ...
mean(dd_coll(bin_index==37,:)); ...
mean(dd_coll(bin_index==38,:)); ...
mean(dd_coll(bin_index==39,:)); ...
mean(dd_coll(bin_index==40,:)); ...
mean(dd_coll(bin_index==41,:)); ...
mean(dd_coll(bin_index==42,:)); ...
mean(dd_coll(bin_index==43,:)); ...
mean(dd_coll(bin_index==44,:)); ...
mean(dd_coll(bin_index==45,:)); ...
mean(dd_coll(bin_index==46,:)); ...
mean(dd_coll(bin_index==47,:)); ...
mean(dd_coll(bin_index==48,:)); ...
mean(dd_coll(bin_index==49,:)); ...
mean(dd_coll(bin_index==50,:)); ...
mean(dd_coll(bin_index==51,:)); ...
mean(dd_coll(bin_index==52,:)); ...
mean(dd_coll(bin_index==53,:)); ...
mean(dd_coll(bin_index==54,:)); ...
mean(dd_coll(bin_index==55,:)); ...
mean(dd_coll(bin_index==56,:)); ...
mean(dd_coll(bin_index==57,:)); ...
mean(dd_coll(bin_index==58,:)); ...
mean(dd_coll(bin_index==59,:)); ...
mean(dd_coll(bin_index==60,:)); ...
mean(dd_coll(bin_index==61,:)); ...
mean(dd_coll(bin_index==62,:)); ...
mean(dd_coll(bin_index==63,:)); ...
mean(dd_coll(bin_index==64,:))]*100;
table = [bin_size table];


% Table S3.2 - Distribution of Absolute Risk Aversion by Covariate Groups
load '.\Replication_Results\KMS_CI_male_64_2_3_0.mat'
mean_male_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_male_64_2_3_1.mat'
mean_male_KMS_1       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_female_64_2_3_0.mat'
mean_female_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_female_64_2_3_1.mat'
mean_female_KMS_1       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_young_64_2_3_0.mat'
mean_young_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_young_64_2_3_1.mat'
mean_young_KMS_1       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_old_64_2_3_0.mat'
mean_old_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_old_64_2_3_1.mat'
mean_old_KMS_1       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_low_64_2_3_0.mat'
mean_low_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_low_64_2_3_1.mat'
mean_low_KMS_1       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_high_64_2_3_0.mat'
mean_high_KMS_0       = mean_KMS_pass;
load '.\Replication_Results\KMS_CI_high_64_2_3_1.mat'
mean_high_KMS_1       = mean_KMS_pass;


load '.\Replication_Results\AS_grid_male_64_2.mat'
theta_AS_male       = theta_pass;
load '.\Replication_Results\AS_grid_female_64_2.mat'
theta_AS_female     = theta_pass;
load '.\Replication_Results\AS_grid_young_64_2.mat'
theta_AS_young      = theta_pass;
load '.\Replication_Results\AS_grid_old_64_2.mat'
theta_AS_old        = theta_pass;
load '.\Replication_Results\AS_grid_low_64_2.mat'
theta_AS_low        = theta_pass;
load '.\Replication_Results\AS_grid_high_64_2.mat'
theta_AS_high       = theta_pass;

mean_male       = r_bar.*theta_AS_male(:, 1)./(theta_AS_male(:, 1)+theta_AS_male(:, 2));
mean_female     = r_bar.*theta_AS_female(:, 1)./(theta_AS_female(:, 1)+theta_AS_female(:, 2));
mean_young      = r_bar.*theta_AS_young(:, 1)./(theta_AS_young(:, 1)+theta_AS_young(:, 2));
mean_old        = r_bar.*theta_AS_old(:, 1)./(theta_AS_old(:, 1)+theta_AS_old(:, 2));
mean_low        = r_bar.*theta_AS_low(:, 1)./(theta_AS_low(:, 1)+theta_AS_low(:, 2));
mean_high       = r_bar.*theta_AS_high(:, 1)./(theta_AS_high(:, 1)+theta_AS_high(:, 2));
var_male        = r_bar.^2.*theta_AS_male(:, 1).*theta_AS_male(:, 2)./((theta_AS_male(:, 1)+theta_AS_male(:, 2)).^2.*(theta_AS_male(:, 1)+theta_AS_male(:, 2)+1));
var_female      = r_bar.^2.*theta_AS_female(:, 1).*theta_AS_female(:, 2)./((theta_AS_female(:, 1)+theta_AS_female(:, 2)).^2.*(theta_AS_female(:, 1)+theta_AS_female(:, 2)+1));
var_young       = r_bar.^2.*theta_AS_young(:, 1).*theta_AS_young(:, 2)./((theta_AS_young(:, 1)+theta_AS_young(:, 2)).^2.*(theta_AS_young(:, 1)+theta_AS_young(:, 2)+1));
var_old         = r_bar.^2.*theta_AS_old(:, 1).*theta_AS_old(:, 2)./((theta_AS_old(:, 1)+theta_AS_old(:, 2)).^2.*(theta_AS_old(:, 1)+theta_AS_old(:, 2)+1));
var_low         = r_bar.^2.*theta_AS_low(:, 1).*theta_AS_low(:, 2)./((theta_AS_low(:, 1)+theta_AS_low(:, 2)).^2.*(theta_AS_low(:, 1)+theta_AS_low(:, 2)+1));
var_high        = r_bar.^2.*theta_AS_high(:, 1).*theta_AS_high(:, 2)./((theta_AS_high(:, 1)+theta_AS_high(:, 2)).^2.*(theta_AS_high(:, 1)+theta_AS_high(:, 2)+1));

Y_inv_AS_male = zeros(size(theta_AS_male,1),length(quantiles_p));
for ii=1:size(theta_AS_male,1)
   theta_temp = theta_AS_male(ii,:);
   Y_inv_AS_male(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));  
end
beta_invY_male = r_bar*Y_inv_AS_male;
Y_inv_AS_female = zeros(size(theta_AS_female,1),length(quantiles_p));
for ii=1:size(theta_AS_female,1)
   theta_temp = theta_AS_female(ii,:);
   Y_inv_AS_female(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));   
end
beta_invY_female = r_bar*Y_inv_AS_female;
Y_inv_AS_young = zeros(size(theta_AS_young,1),length(quantiles_p));
for ii=1:size(theta_AS_young,1)
   theta_temp = theta_AS_young(ii,:);
   Y_inv_AS_young(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));  
end
beta_invY_young = r_bar*Y_inv_AS_young;
Y_inv_AS_old= zeros(size(theta_AS_old,1),length(quantiles_p));
for ii=1:size(theta_AS_old,1)
   theta_temp = theta_AS_old(ii,:);
   Y_inv_AS_old(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));   
end
beta_invY_old = r_bar*Y_inv_AS_old;
Y_inv_AS_low= zeros(size(theta_AS_low,1),length(quantiles_p));
for ii=1:size(theta_AS_low,1)
   theta_temp = theta_AS_low(ii,:);
   Y_inv_AS_low(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));  
end
beta_invY_low = r_bar*Y_inv_AS_low;
Y_inv_AS_high= zeros(size(theta_AS_high,1),length(quantiles_p));
for ii=1:size(theta_AS_high,1)
   theta_temp = theta_AS_high(ii,:);
   Y_inv_AS_high(ii,:) = betainv(quantiles_p,theta_temp(1),theta_temp(2));   
end
beta_invY_high = r_bar*Y_inv_AS_high;

male_ra         = [min(mean_male_KMS_0) min(beta_invY_male(:,1)) min(beta_invY_male(:,2)); max(mean_male_KMS_1) max(beta_invY_male(:,1)) max(beta_invY_male(:,2))]; 
female_ra       = [min(mean_female_KMS_0) min(beta_invY_female(:,1)) min(beta_invY_female(:,2)); max(mean_female_KMS_1) max(beta_invY_female(:,1)) max(beta_invY_female(:,2))]; 
young_ra        = [min(mean_young_KMS_0) min(beta_invY_young(:,1)) min(beta_invY_young(:,2)); max(mean_young_KMS_1) max(beta_invY_young(:,1)) max(beta_invY_young(:,2))]; 
old_ra          = [min(mean_old_KMS_0) min(beta_invY_old(:,1)) min(beta_invY_old(:,2)); max(mean_old_KMS_1) max(beta_invY_old(:,1)) max(beta_invY_old(:,2))]; 
low_ra          = [min(mean_low_KMS_0) min(beta_invY_low(:,1)) min(beta_invY_low(:,2)); max(mean_low_KMS_1) max(beta_invY_low(:,1)) max(beta_invY_low(:,2))]; 
high_ra         = [min(mean_high_KMS_0) min(beta_invY_high(:,1)) min(beta_invY_high(:,2)); max(mean_high_KMS_1) max(beta_invY_high(:,1)) max(beta_invY_high(:,2))]; 

male_rp         = (1./male_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*male_ra  ))-(rp_prob.*rp_loss)
female_rp       = (1./female_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*female_ra  ))-(rp_prob.*rp_loss)
young_rp        = (1./young_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*young_ra  ))-(rp_prob.*rp_loss)
old_rp          = (1./old_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*old_ra  ))-(rp_prob.*rp_loss)
low_rp          = (1./low_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*low_ra  ))-(rp_prob.*rp_loss)
hgih_rp         = (1./high_ra  ).*log((1-rp_prob)+rp_prob.*exp(rp_loss.*high_ra  ))-(rp_prob.*rp_loss)


% Table S3.3- Distrbution of Choice Set Size by Covariate Groups
load .\Replication_Results\KMS_CI_male_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_male_64_3_11_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_female_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_female_64_3_11_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_young_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_young_64_3_11_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_old_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_old_64_3_11_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_low_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_low_64_3_11_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_high_64_3_10_1
max(theta_pass_KMS)
load .\Replication_Results\KMS_CI_high_64_3_11_1
max(theta_pass_KMS)


% Figure S3.2 - Outer region on Admissible PDFs
[plot_pdf64,plot_pdfAS_LB,plot_pdfAS_UB]    = get_PDF_plot(r_bar,theta_AS_64,40,0);
[plot_pdfUR]                                = get_PDF_plot(r_bar,theta_UR   ,40,1);
[plot_pdfASR]                               = get_PDF_plot(r_bar,theta_ASR  ,40,1);

figure
plot(plot_pdfAS_LB(1,:),plot_pdfAS_LB(2,:),'black')
hold on
plot(plot_pdfAS_UB(1,:),plot_pdfAS_UB(2,:),'black')
patch([plot_pdfAS_LB(1,:) fliplr(plot_pdfAS_LB(1,:))], [plot_pdfAS_LB(2,:) fliplr(plot_pdfAS_UB(2,:))], [0,0,0]+.85)
b1=plot(plot_pdfUR(1,:),plot_pdfUR(2,:),'Color',[0 .5 0])
b2=plot(plot_pdfASR(1,:),plot_pdfASR(2,:),'blue')
legend([b1 b2],'UR','ASR','fontsize',14)
legend boxoff
xlabel('$\nu$','Interpreter','Latex')
ylabel('f$(\nu)$','interpreter','Latex')
xticks([0 .01 .02 .03])
ax=gca;
ax.XAxis.Exponent = -2;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_2')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_2.eps -painters -native


