clear variables
close all

% Define Problem:
r_bar                   = .03;
ind_binning             = 8;
covariate_group         = 'all';
bin_N                   = ind_binning^2;
logit_model             = 0;
logit_factor_vals       = [.1 .25 .5];

Zoom_In = 1e12;

load './Replication_Results/AS_grid_all_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_base    = sort(unique(var_pass));
mean_min_base    = 0*var_temp_base;
mean_max_base    = 0*var_temp_base;
for vv_temp = 1:length(var_temp_base)
    mean_min_base(vv_temp) = min(mean_pass(var_temp_base(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_base(vv_temp) = max(mean_pass(var_temp_base(vv_temp)==var_pass)); %#ok<*SAGROW>
end

load './Replication_Results/AS_grid_all_64_2_LogitFactor0.1.mat'  
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_l1    = sort(unique(var_pass));
mean_min_l1    = 0*var_temp_l1;
mean_max_l1    = 0*var_temp_l1;
for vv_temp = 1:length(var_temp_l1)
    mean_min_l1(vv_temp) = min(mean_pass(var_temp_l1(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_l1(vv_temp) = max(mean_pass(var_temp_l1(vv_temp)==var_pass)); %#ok<*SAGROW>
end

load './Replication_Results/AS_grid_all_64_2_LogitFactor0.25.mat'  
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_l2    = sort(unique(var_pass));
mean_min_l2    = 0*var_temp_l2;
mean_max_l2    = 0*var_temp_l2;
for vv_temp = 1:length(var_temp_l2)
    mean_min_l2(vv_temp) = min(mean_pass(var_temp_l2(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_l2(vv_temp) = max(mean_pass(var_temp_l2(vv_temp)==var_pass)); %#ok<*SAGROW>
end

load './Replication_Results/AS_grid_all_64_2_LogitFactor0.5.mat'  
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_l3    = sort(unique(var_pass));
mean_min_l3    = 0*var_temp_l3;
mean_max_l3    = 0*var_temp_l3;
for vv_temp = 1:length(var_temp_l3)
    mean_min_l3(vv_temp) = min(mean_pass(var_temp_l3(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_l3(vv_temp) = max(mean_pass(var_temp_l3(vv_temp)==var_pass)); %#ok<*SAGROW>
end

mean_base_plot1 = r_bar*[mean_max_base(1) mean_min_base mean_max_base(end)]/Zoom_In;
mean_base_plot2 = r_bar*[mean_min_base(1) mean_max_base mean_min_base(end)]/Zoom_In;
var_base_plot1  = r_bar^2*[var_temp_base(1) var_temp_base var_temp_base(end)]/Zoom_In;

mean_l1_plot1 = r_bar*[mean_max_l1(1) mean_min_l1 mean_max_l1(end)]/Zoom_In;
mean_l1_plot2 = r_bar*[mean_min_l1(1) mean_max_l1 mean_min_l1(end)]/Zoom_In;
var_l1_plot1  = r_bar^2*[var_temp_l1(1) var_temp_l1 var_temp_l1(end)]/Zoom_In;

mean_l2_plot1 = r_bar*[mean_max_l2(1) mean_min_l2 mean_max_l2(end)]/Zoom_In;
mean_l2_plot2 = r_bar*[mean_min_l2(1) mean_max_l2 mean_min_l2(end)]/Zoom_In;
var_l2_plot1  = r_bar^2*[var_temp_l2(1) var_temp_l2 var_temp_l2(end)]/Zoom_In;

mean_l3_plot1 = r_bar*[mean_max_l3(1) mean_min_l3 mean_max_l3(end)]/Zoom_In;
mean_l3_plot2 = r_bar*[mean_min_l3(1) mean_max_l3 mean_min_l3(end)]/Zoom_In;
var_l3_plot1  = r_bar^2*[var_temp_l3(1) var_temp_l3 var_temp_l3(end)]/Zoom_In;


% Figure 5.1(a)
figure
plot(mean_base_plot1,var_base_plot1,'k')
hold on
plot(mean_base_plot2,var_base_plot1,'k')
patch([mean_base_plot1 fliplr(mean_base_plot2)], [var_base_plot1 fliplr(var_base_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .005])
ylim([0 .00007])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Fig_5_1a')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Fig_5_1a.eps -painters -native

% Figure 5.1(b)
figure
plot(mean_base_plot1,var_base_plot1,'k','Linewidth',.01)
hold on
plot(mean_base_plot2,var_base_plot1,'k','Linewidth',.01)
patch([mean_base_plot1 fliplr(mean_base_plot2)], [var_base_plot1 fliplr(var_base_plot1)],[0 0 0] + .85)
b1=plot(mean_l1_plot1,var_l1_plot1,'k','Linewidth',1.75)
plot(mean_l1_plot2,var_l1_plot1,'k','Linewidth',1.75)
b2=plot(mean_l2_plot1,var_l2_plot1,'--k','Linewidth',1.75)
plot(mean_l2_plot2,var_l2_plot1,'--k','Linewidth',1.75)
b3=plot(mean_l3_plot1,var_l3_plot1,'-.k','Linewidth',1.75)
plot(mean_l3_plot2,var_l3_plot1,'-.k','Linewidth',1.75)

legend([b1 b2 b3],'0.10','0.25','0.50','fontsize',14)
legend boxoff
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .005])
ylim([0 .00007])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Fig_5_1b')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Fig_5_1b.eps -painters -native

%% Figure S3.1
load './Replication_Results/AS_grid_male_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_male    = sort(unique(var_pass));
mean_min_male    = 0*var_temp_male;
mean_max_male    = 0*var_temp_male;
for vv_temp = 1:length(var_temp_male)
    mean_min_male(vv_temp) = min(mean_pass(var_temp_male(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_male(vv_temp) = max(mean_pass(var_temp_male(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_male_plot1 = r_bar*[mean_max_male(1) mean_min_male mean_max_male(end)]/Zoom_In;
mean_male_plot2 = r_bar*[mean_min_male(1) mean_max_male mean_min_male(end)]/Zoom_In;
var_male_plot1  = r_bar^2*[var_temp_male(1) var_temp_male var_temp_male(end)]/Zoom_In;

figure
plot(mean_male_plot1,var_male_plot1,'k')
hold on
plot(mean_male_plot2,var_male_plot1,'k')
patch([mean_male_plot1 fliplr(mean_male_plot2)], [var_male_plot1 fliplr(var_male_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1a')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1a.eps -painters -native

load './Replication_Results/AS_grid_female_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_female    = sort(unique(var_pass));
mean_min_female    = 0*var_temp_female;
mean_max_female    = 0*var_temp_female;
for vv_temp = 1:length(var_temp_female)
    mean_min_female(vv_temp) = min(mean_pass(var_temp_female(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_female(vv_temp) = max(mean_pass(var_temp_female(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_female_plot1 = r_bar*[mean_max_female(1) mean_min_female mean_max_female(end)]/Zoom_In;
mean_female_plot2 = r_bar*[mean_min_female(1) mean_max_female mean_min_female(end)]/Zoom_In;
var_female_plot1  = r_bar^2*[var_temp_female(1) var_temp_female var_temp_female(end)]/Zoom_In;

figure
plot(mean_female_plot1,var_female_plot1,'k')
hold on
plot(mean_female_plot2,var_female_plot1,'k')
patch([mean_female_plot1 fliplr(mean_female_plot2)], [var_female_plot1 fliplr(var_female_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1b')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1b.eps -painters -native

load './Replication_Results/AS_grid_young_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_young    = sort(unique(var_pass));
mean_min_young    = 0*var_temp_young;
mean_max_young    = 0*var_temp_young;
for vv_temp = 1:length(var_temp_young)
    mean_min_young(vv_temp) = min(mean_pass(var_temp_young(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_young(vv_temp) = max(mean_pass(var_temp_young(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_young_plot1 = r_bar*[mean_max_young(1) mean_min_young mean_max_young(end)]/Zoom_In;
mean_young_plot2 = r_bar*[mean_min_young(1) mean_max_young mean_min_young(end)]/Zoom_In;
var_young_plot1  = r_bar^2*[var_temp_young(1) var_temp_young var_temp_young(end)]/Zoom_In;

figure
plot(mean_young_plot1,var_young_plot1,'k')
hold on
plot(mean_young_plot2,var_young_plot1,'k')
patch([mean_young_plot1 fliplr(mean_young_plot2)], [var_young_plot1 fliplr(var_young_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1c')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1c.eps -painters -native

load './Replication_Results/AS_grid_old_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_old    = sort(unique(var_pass));
mean_min_old    = 0*var_temp_old;
mean_max_old    = 0*var_temp_old;
for vv_temp = 1:length(var_temp_old)
    mean_min_old(vv_temp) = min(mean_pass(var_temp_old(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_old(vv_temp) = max(mean_pass(var_temp_old(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_old_plot1 = r_bar*[mean_max_old(1) mean_min_old mean_max_old(end)]/Zoom_In;
mean_old_plot2 = r_bar*[mean_min_old(1) mean_max_old mean_min_old(end)]/Zoom_In;
var_old_plot1  = r_bar^2*[var_temp_old(1) var_temp_old var_temp_old(end)]/Zoom_In;

figure
plot(mean_old_plot1,var_old_plot1,'k')
hold on
plot(mean_old_plot2,var_old_plot1,'k')
patch([mean_old_plot1 fliplr(mean_old_plot2)], [var_old_plot1 fliplr(var_old_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1d')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1d.eps -painters -native

load './Replication_Results/AS_grid_low_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_low    = sort(unique(var_pass));
mean_min_low    = 0*var_temp_low;
mean_max_low    = 0*var_temp_low;
for vv_temp = 1:length(var_temp_low)
    mean_min_low(vv_temp) = min(mean_pass(var_temp_low(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_low(vv_temp) = max(mean_pass(var_temp_low(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_low_plot1 = r_bar*[mean_max_low(1) mean_min_low mean_max_low(end)]/Zoom_In;
mean_low_plot2 = r_bar*[mean_min_low(1) mean_max_low mean_min_low(end)]/Zoom_In;
var_low_plot1  = r_bar^2*[var_temp_low(1) var_temp_low var_temp_low(end)]/Zoom_In;

figure
plot(mean_low_plot1,var_low_plot1,'k')
hold on
plot(mean_low_plot2,var_low_plot1,'k')
patch([mean_low_plot1 fliplr(mean_low_plot2)], [var_low_plot1 fliplr(var_low_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1e')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1e.eps -painters -native

load './Replication_Results/AS_grid_high_64_2.mat'
mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;
for mm_temp = 1:length(mean_temp)  
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp_high    = sort(unique(var_pass));
mean_min_high    = 0*var_temp_high;
mean_max_high    = 0*var_temp_high;
for vv_temp = 1:length(var_temp_high)
    mean_min_high(vv_temp) = min(mean_pass(var_temp_high(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max_high(vv_temp) = max(mean_pass(var_temp_high(vv_temp)==var_pass)); %#ok<*SAGROW>
end
mean_high_plot1 = r_bar*[mean_max_high(1) mean_min_high mean_max_high(end)]/Zoom_In;
mean_high_plot2 = r_bar*[mean_min_high(1) mean_max_high mean_min_high(end)]/Zoom_In;
var_high_plot1  = r_bar^2*[var_temp_high(1) var_temp_high var_temp_high(end)]/Zoom_In;

figure
plot(mean_high_plot1,var_high_plot1,'k')
hold on
plot(mean_high_plot2,var_high_plot1,'k')
patch([mean_high_plot1 fliplr(mean_high_plot2)], [var_high_plot1 fliplr(var_high_plot1)],[0 0 0] + .85)
xlabel('E$(\nu)$','Interpreter','Latex')
ylabel('Var$(\nu)$','interpreter','Latex')
xlim([0 .0055])
ylim([0 .00008])
ax=gca;
ax.XAxis.FontSize = 14;
ax.YAxis.FontSize = 14;
hold off
savefig ('./Replication_Figures/Figure_S3_1f')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Figure_S3_1f.eps -painters -native
