clear variables
close all
%% Specify DGP and construct the choice data.
N_menu          = 101;

Kappa_Grand_List      = 10:20:90;
RCL_Kappa_Grand_List  = N_menu+zeros(1,length(Kappa_Grand_List));
Correlation_Grand_List= zeros(1,length(Kappa_Grand_List));

Kappa_Grand_List     = [ Kappa_Grand_List      30 30 30 70 70 70];
RCL_Kappa_Grand_List = [RCL_Kappa_Grand_List   30 30 30 70 70 70];
Correlation_Grand_List=[Correlation_Grand_List 0  1  2  0  1  2 ];

for KK=1:length(Kappa_Grand_List)
Kappa           = Kappa_Grand_List(KK); % minimum # of alternatives in the choice set used by the researcher
RCL_Kappa       = RCL_Kappa_Grand_List(KK); % minimum # of alternative in the choice set used to generate data
Correlation     = Correlation_Grand_List(KK); % 0 - no correlation; 1 - with preferences; 2 - with price


DD_list         = linspace(10,1010,N_menu); 
PP_mult         = (DD_list(end)-DD_list)./DD_list(end); 

p_bar_min               = 10;
p_bar_max               = 1000;
N_p_bar                 = 100;
pp_bar                  = linspace(p_bar_min,p_bar_max,N_p_bar);
PP_list                 = pp_bar'*PP_mult;

lambda                  =  .10;
r_bar                   =  .01; 
Nods                    = 1001;   
NrL                     = 0;
NrH                     = 1;
TT_r                    = linspace(NrL,NrH,Nods); 
MM_r                    = length(TT_r);
TT_r_expec              = [0 .5*(TT_r(1:end-1)+TT_r(2:end))];
beta_1                  =  1;
beta_2                  =  1;
mean_DGP                =  beta_1/(beta_1+beta_2)*r_bar;
var_DGP                 =  beta_1*beta_2/(beta_1+beta_2)^2/(beta_1+beta_2+1)*r_bar^2;
weights                 = [0 diff(betacdf(TT_r,beta_1,beta_2))];
emp_choice_dist         = zeros(N_p_bar,N_menu);

if RCL_Kappa==N_menu
    first_best              =   construct_FST_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar);
    cum_X_best              =  first_best;
    for best_ind =2:N_menu-Kappa+1
        X_best                  =   construct_X_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar,best_ind);
        cum_X_best              =   X_best+cum_X_best;
    end
    
    for pp = 1:length(pp_bar)
        emp_choice_dist(pp,:)     = (squeeze(first_best(pp,:,:)))*weights';
    end
    
elseif RCL_Kappa<N_menu && Correlation==0
    RCL_prob = zeros(1,N_menu);
    for m=1:N_menu-Kappa+1
        RCL_prob(m)=nchoosek(N_menu-m,Kappa-1)/nchoosek(N_menu,Kappa);
    end
    
    N_menu_best = zeros(N_p_bar,N_menu,MM_r);
    cum_X_best  = zeros(N_p_bar,N_menu,MM_r);
    for best_ind=1:N_menu
        X_best                        =   construct_X_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar, best_ind);
        N_menu_best                   =   N_menu_best+best_ind*X_best;
        if best_ind<N_menu-Kappa
            cum_X_best                    = cum_X_best+X_best;
        end
    end
    
    RCL_weighted_first_best  =   RCL_prob(N_menu_best);
    for pp = 1:length(pp_bar)
        emp_choice_dist(pp,:)=  (squeeze(RCL_weighted_first_best(pp,:,:)))*weights';
    end
    
elseif RCL_Kappa<N_menu && Correlation==1
    DGP_Kappa=RCL_Kappa;
    emp_first_best_low              =   construct_FST_best(repmat(lambda,N_p_bar,1),PP_list(:,              1:DGP_Kappa),DD_list(              1:DGP_Kappa),TT_r_expec(round(end/2)+1:end)*r_bar);
    emp_first_best_high             =   construct_FST_best(repmat(lambda,N_p_bar,1),PP_list(:,end-DGP_Kappa+1:    end  ),DD_list(end-DGP_Kappa+1:end      ),TT_r_expec(1:round(end/2)    )*r_bar);
    
    [Al,Bl,Cl] = size(emp_first_best_low);
    [Ah,Bh,Ch] = size(emp_first_best_high);
    
    emp_first_best_low              =  cat(2,emp_first_best_low, zeros(Al,N_menu-Bl,Cl));
    emp_first_best_high             =  cat(2, zeros(Ah,N_menu-Bh,Ch), emp_first_best_high);
    emp_first_best                  =  cat(3,emp_first_best_high,emp_first_best_low);
    
   first_best               =  construct_FST_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar);
   cum_X_best               =  first_best;
   for best_ind =2:N_menu-Kappa+1
       X_best               =  construct_X_best(repmat(lambda,N_p_bar,1),pp_bar'*PP_mult,DD_list,TT_r_expec*r_bar, best_ind);
       cum_X_best           =  X_best+cum_X_best;
   end
   
   for pp = 1:length(pp_bar)
       emp_choice_dist(pp,:)= (squeeze(emp_first_best(pp,:,:)))*weights';
   end

elseif RCL_Kappa<N_menu && Correlation==2
    DGP_Kappa=RCL_Kappa;
    b = -(N_menu-DGP_Kappa)/(N_p_bar-1);
    a = 1-b*N_p_bar;
    
    Kappa_start = a+b*(1:N_p_bar);
    Kappa_start = round(Kappa_start);
    
    emp_first_best = zeros(N_p_bar,N_menu,MM_r);
    for ii=1:N_p_bar
        temp = construct_FST_best(lambda,pp_bar(ii)*PP_mult(Kappa_start(ii):Kappa_start(ii)+DGP_Kappa-1),DD_list(Kappa_start(ii):Kappa_start(ii)+DGP_Kappa-1),TT_r_expec*r_bar);
        emp_first_best(ii,:,:) =   cat(2,zeros(1,Kappa_start(ii)-1,MM_r),temp,zeros(1,N_menu-(Kappa_start(ii)+DGP_Kappa-1),MM_r));
    end
    
    first_best              =  construct_FST_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar);
    cum_X_best              =  first_best;
    for best_ind =2:N_menu-Kappa+1
        X_best              =  construct_X_best(repmat(lambda,N_p_bar,1),PP_list,DD_list,TT_r_expec*r_bar, best_ind);
        cum_X_best          =  X_best+cum_X_best;
    end
   for pp = 1:length(pp_bar)
       emp_choice_dist(pp,:)= (squeeze(emp_first_best(pp,:,:)))*weights';
   end
end

Sample_Size      = 100000; % Desired sample size
Size_per_pp_bar  = Sample_Size/N_p_bar; % the resulting # of observations per price level - assuming each price is associated with equal number of observations
emp_choice_count = round(emp_choice_dist*Size_per_pp_bar); %  choice count per pp_bar
n_types          = sum(emp_choice_count,2);            % # of observations per pp_bar  
Sample_Size      = sum(n_types);                       % Sample Size - will be the same as the desired Sample size, subject to rounding.

%% Set the inequalities to check
tic
DDL_Sets          = [];
for ii = 0 : Kappa-2
    DDL_Sets          = [DDL_Sets
        DD_list(1:1+ii) zeros(1,Kappa-2-ii)]; %#ok<*AGROW>
end
DD_listR          = DD_list(end:-1:1);
DDH_Sets          = [];
for ii = 0 : Kappa-2
    DDH_Sets          = [DDH_Sets
        DD_listR(1:1+ii) zeros(1,Kappa-2-ii)];
end

DD_Sets=[DDH_Sets
         DDL_Sets];

temp =sort(DD_Sets,2,'descend');

C = unique(temp,'rows');
DD_Sets = C;

%% construct data moments and correponding bootstrap objects
[f_ineq,f_ineq_keep,~,phi_jt] = moments_w_simulate(emp_choice_count,length(pp_bar),Sample_Size,DD_Sets,DD_list);

cum_count              = emp_choice_count';
cum_count              = cumsum(cum_count(:));
cum_count_with_0       = [0; cum_count];

seed                    = 0;
B                       = 1000;
emp_choice_count_BB    = zeros(length(cum_count),B);

% Bootstrap
f_b          = zeros(length(f_ineq) ,B);
n_types_b    = zeros(length(n_types),B);
parfor bb = 1:B
    cum_count_with_0bb =cum_count_with_0;
    
    stream=RandStream('mlfg6331_64','Seed',seed);
    RandStream.setGlobalStream(stream);
    stream.Substream = bb + B*10^3;
    
    ind_bb                 = ceil(Sample_Size*rand(Sample_Size,1));
    emp_choice_count_bb    = zeros(length(cum_count),1);
    
    for ii=1:length(cum_count)
        emp_choice_count_bb(ii)     = sum(ind_bb>cum_count_with_0bb(ii) & ind_bb<=cum_count_with_0bb(ii+1));
    end
    
    emp_choice_count_BB(:,bb) =   emp_choice_count_bb;
    emp_choice_count_bb       =   reshape(emp_choice_count_bb,N_menu,N_p_bar)';  
    f_temp             = moments_w_simulate(emp_choice_count_bb,length(pp_bar),Sample_Size,DD_Sets,DD_list);
    f_b(:, bb)         = f_temp;
    n_types_b(:,bb)    = sum(emp_choice_count_bb,2);
end

%% Construct the input into the moments function
LB_RA   = zeros(N_p_bar,size(DD_Sets,1));
UB_RA   = zeros(N_p_bar,size(DD_Sets,1));
cum_XX_best =cum_X_best>0;
for tt=1:N_p_bar
    for dd=1:size(DD_Sets,1)
        temp_deds           = ismember(DD_list,DD_Sets(dd,:));
        temp_grid           = squeeze(max(cum_XX_best(tt,temp_deds==1,:),[],2)); % just need one of the included deds to have indicator
        ind_change_count    = sum(abs(temp_grid(2:end)-temp_grid(1:end-1)));
        if ind_change_count>2
            disp('multiple changes')
            disp(tt)
            disp(dd)
            keyboard
        elseif temp_grid(1)==1 && temp_grid(end)==1 && temp_grid(2)==0
            disp('multiple changes - r0 thing')
            disp(tt)
            disp(dd)
            keyboard            
        end
        if max(temp_grid)==1 % There is ever an intersection, else just leave bounds as zeros
            LB_RA(tt,dd) = TT_r(find(temp_grid==1,1,'first'));
            UB_RA(tt,dd) = TT_r(find(temp_grid==1,1,'last'));
        end
    end
end
toc
pre_time_spent = toc;
%% Set AS parameters:
tic

alpha                   =.05;
eta                     = 10^-6; 
kappa                   = sqrt(.3*log(Sample_Size));
Bn_param                = sqrt(.4*log(Sample_Size)/log(log(Sample_Size))); 
f                       = f_ineq;
f_keep                  = f_ineq_keep;
clear f_ineq f_ineq_keep emp_choice_count_BB emp_choice_dist emp_choice_count cum_X_best first_best X_best
alpha_adj = alpha - eta; 

tau_t               = n_types/Sample_Size;
tau_tb              = n_types_b/Sample_Size;
N_j                 = length(f);
N_t                 = length(n_types);
N_d                 = size(DD_Sets,1);
N_types             = repmat(n_types,1,N_d)';
N_types             = N_types(:);
N_types             = [N_types; ones(N_d,1)*Sample_Size];

ind_type_t_in_j                     = zeros(N_t,N_j);
ind_type_t_in_j(:,end-N_d+1:end)    = 1;  % Aggregate bin
for tt=1:N_t
   
   ind_type_t_in_j(tt,(tt-1)*N_d+1:tt*N_d)=1;
end

%% set the master grid 

mean_low        = 0;
mean_high       = 1;
var_low         = 0;
var_high        = 0.25;
grid_level      = 4;

N_master_mean   = 100*2^(grid_level-1);
N_master_var    =  25*2^(grid_level-1);
master_means    = linspace(mean_low,mean_high,N_master_mean+1);
master_vars     = linspace(var_low,var_high,N_master_var+1);
master_means    = master_means(2:end);
master_vars     = master_vars(2:end);
master_alpha    = (master_means.^3.*(1./master_means-1))'*(1./master_vars)-repmat(master_means',1,length(master_vars));
master_beta     = master_alpha.*repmat(((1-master_means)./master_means)',1,length(master_vars));

MASTER_BETA             = [master_alpha(:) master_beta(:)];
temp_mean               = repmat(master_means,1,N_master_var);
temp_var                = repmat(master_vars,N_master_mean,1);
MASTER_MEAN_VAR         = [temp_mean(:) temp_var(:)];
MASTER_pass             = zeros(N_master_mean*N_master_var,1);
MASTER_checked          = zeros(N_master_mean*N_master_var,1);

MASTER_Matrix_Pass      =  zeros(N_master_mean,N_master_var);
MASTER_Matrix_Checked   =  zeros(N_master_mean,N_master_var);
MASTER_Matrix_Check     =  zeros(N_master_mean,N_master_var);

GRID_MATRIX             = zeros(N_master_mean,N_master_var,grid_level);
mean_grid_index         = zeros(N_master_mean,grid_level);
var_grid_index          = zeros(N_master_var,grid_level);

for grid_refinement=1:grid_level
mean_grid_index((1:(2^grid_level/2^grid_refinement):N_master_mean),grid_refinement)  = 1;
var_grid_index( (1:(2^grid_level/2^grid_refinement):N_master_var),grid_refinement)   = 1;
GRID_MATRIX(:,:,grid_refinement) =  mean_grid_index(:,grid_refinement)*var_grid_index(:,grid_refinement)';
end
CHECK_now  = GRID_MATRIX(:,:,1);
CHECK_now  = CHECK_now(:);
THETA_pass = [];

%% Andrews-Shi
number_of_thetas_checked = 0;
for grid_refinement = 1:grid_level
    disp(grid_refinement)

alpha_smart = MASTER_BETA(CHECK_now>0,1);
beta_smart  = MASTER_BETA(CHECK_now>0,2);

beta_smart= beta_smart(alpha_smart>0);
alpha_smart= alpha_smart(alpha_smart>0);

theta_grid(:,1)    = alpha_smart(:);
theta_grid(:,2)    = beta_smart(:);
number_of_thetas_checked = number_of_thetas_checked + length(theta_grid);

c_vals       = zeros(size(theta_grid,1),1);
CV           = zeros(size(theta_grid,1),1);
parfor theta_index=1:size(theta_grid,1)
    temp_theta                      = theta_grid(theta_index,:);
    mtheta_jt_temp                  = moments_theta_simulate(temp_theta,LB_RA,UB_RA,ind_type_t_in_j,N_j,N_t,N_d);
    g_ineq_temp                     = mtheta_jt_temp'*tau_t;
    
    temp                            = mtheta_jt_temp'*tau_tb;
    tau_mjt_squared                 = (mtheta_jt_temp.^2)'*tau_t;
    phi_jt_mjt                      = sum(phi_jt'.*mtheta_jt_temp,1);    
    f_stdev_temp                    = (f+tau_mjt_squared-(2/Sample_Size)*phi_jt_mjt') -((f-g_ineq_temp).^2);  
    mtheta_jt_temp                  = [];
    tau_mjt_squared                 = [];
    phi_jt_mjt                      = [];     
    f_stdev_temp(f_stdev_temp<=0)   = 10^(-12);
    f_stdev_temp                    = (f_stdev_temp).^(.5);
    
    m_theta                         = sqrt(Sample_Size)*((f - g_ineq_temp)./f_stdev_temp); 
    m_theta(f_keep == 0,:)          = [];
   
    G_temp                          = sqrt(Sample_Size)./f_stdev_temp.*((f_b-temp)-(f-g_ineq_temp)); 
    G_temp(f_keep==0,:)             = [];
    xi                              = (1./kappa).*m_theta; 
    phi_test                        = KMS_AUX1_phifunc_AS2(xi,Bn_param);   
    S_3_boot                        = max(0,max(G_temp+repmat(phi_test,1,B)));
    c_vals(theta_index)             = quantile(S_3_boot,1-alpha_adj) + eta; 
    CV(theta_index)                 = sum(max(0,m_theta-c_vals(theta_index)).^2); 
end
theta_pass  = theta_grid(CV==0,:);
c_vals_pass = c_vals(CV==0);
THETA_pass  = [THETA_pass
               theta_pass]; 
           
MASTER_pass    = MASTER_pass   +(min(abs(master_alpha(:)-theta_pass(:,1)')+abs(master_beta(:)-theta_pass(:,2)'),[],2)<1e-8);

temp_alpha = master_alpha(:);
temp_beta  = master_beta(:);
N_master   = length(MASTER_checked);

for temp=1:10
MASTER_checked((temp-1)*N_master/10+1:temp*N_master/10) = MASTER_checked((temp-1)*N_master/10+1:temp*N_master/10)+(min(abs(temp_alpha((temp-1)*N_master/10+1:temp*N_master/10)-theta_grid(:,1)')+abs(temp_beta((temp-1)*N_master/10+1:temp*N_master/10)-theta_grid(:,2)'),[],2)<1e-8);
end

MASTER_Matrix_Pass(MASTER_pass==1)=1;
MASTER_Matrix_Checked(MASTER_checked==1)=1;

for ii=1:N_master_mean
    for jj=1:N_master_var
       if  MASTER_Matrix_Pass(ii,jj)==1
       MASTER_Matrix_Check((max(1,ii-grid_level-1):1:min(ii+grid_level+1,N_master_mean)),(max(1,jj-grid_level-1):1: min(jj+grid_level+1,N_master_var)))=1;
       end
    end
end

MASTER_Matrix_Check     = MASTER_Matrix_Check-MASTER_Matrix_Check.*MASTER_Matrix_Checked;

if grid_refinement<grid_level
MASTER_Matrix_Check_now = MASTER_Matrix_Check.*GRID_MATRIX(:,:,grid_refinement+1);
CHECK_now               = MASTER_Matrix_Check_now(:);
end

clear theta_grid
end
toc
time_spent = toc;
MASTER_Matrix_Pass(MASTER_pass==1)=1;
THETA_pass_Check = MASTER_BETA(MASTER_Matrix_Pass(:)>0,:);  
mean_pass = THETA_pass(:,1)./(THETA_pass(:,1)+THETA_pass(:,2));
var_pass  = THETA_pass(:,1).*THETA_pass(:,2)./(THETA_pass(:,1)+THETA_pass(:,2)).^2./(THETA_pass(:,1)+THETA_pass(:,2)+1);

disp([ 'Correlation Correlation Correlation Correlation Correlation Correlation  ' num2str(Correlation)])
disp(['number of total inequalities     ' num2str(length(f))])
disp(['number of thetas_checked     ' num2str(number_of_thetas_checked)])
disp(['time spent     ' num2str(time_spent/3600) '     hours'])
disp(['time spent per one theta     ' num2str(time_spent/number_of_thetas_checked) '    secs'])



savefile = ['.\Replication_Results\Simulations_NbarP',num2str(N_p_bar), '_Nmenu', num2str(N_menu),'_Kappa', num2str(Kappa),'_RCLKappa', num2str(RCL_Kappa),...
               '_Corr',num2str(Correlation),'_','_GridLev', num2str(grid_level), '.mat'];
save(savefile,'mean_DGP','var_DGP','theta_pass','THETA_pass','THETA_pass_Check','mean_pass','var_pass','Sample_Size','r_bar','alpha','eta','kappa','Bn_param','c_vals_pass','f','f_keep','number_of_thetas_checked','pre_time_spent','time_spent');

end
%% Simulation Table 6.1. Panel A
clear variables
close all
N_p_bar         = 100;
N_menu          = 101;
grid_level      = 4;

Kappa_Grand_List      = 10:20:90;
RCL_Kappa_Grand_List  = N_menu+zeros(1,length(Kappa_Grand_List));
Correlation_Grand_List= zeros(1,length(Kappa_Grand_List));

Kappa_Grand_List     = [ Kappa_Grand_List      30 30 30 70 70 70];
RCL_Kappa_Grand_List = [RCL_Kappa_Grand_List   30 30 30 70 70 70];
Correlation_Grand_List=[Correlation_Grand_List 0  1  2  0  1  2 ];
disp('Table 6.1. Panel A')
disp( 'q  |D|  kappa   Correlation  num_of_ineq pre_process_time execution_time eval_points execution_time_per_eval_point ')

for KK=1:length(Kappa_Grand_List)
Kappa           = Kappa_Grand_List(KK); % minimum # of alternatives in the choice set used by the researcher
RCL_Kappa       = RCL_Kappa_Grand_List(KK); % minimum # of alternative in the choice set used to generate data
Correlation     = Correlation_Grand_List(KK); % 0 - no correlation; 1 - with preferences; 2 - with price
loadfile = ['.\Replication_Results\Simulations_NbarP',num2str(N_p_bar), '_Nmenu', num2str(N_menu),'_Kappa', num2str(Kappa),'_RCLKappa', num2str(RCL_Kappa),...
               '_Corr',num2str(Correlation),'_','_GridLev', num2str(grid_level), '.mat'];
load(loadfile)

disp([ num2str(RCL_Kappa) '  ' num2str(N_menu) '  ' num2str(Kappa) '  ' num2str(Correlation) '  ' num2str(length(f))  '  ' num2str(pre_time_spent/3600,2) '  ' num2str(time_spent/3600,2) '  ' num2str(number_of_thetas_checked)  '  ' num2str(time_spent/number_of_thetas_checked,2) ])
disp('                              ')
end

%% Simulations figure 1:
clear variables
close all
Kappa_List       = [10 50 90];
N_p_bar         = 100;
N_menu          = 101;
RCL_Kappa       = 101;
Correlation     = 0;
grid_level      = 4;
for ii=1:length(Kappa_List)
Kappa           = Kappa_List(ii);

loadfile = ['.\Replication_Results\Simulations_NbarP',num2str(N_p_bar), '_Nmenu', num2str(N_menu),'_Kappa', num2str(Kappa),'_RCLKappa', num2str(RCL_Kappa),...
               '_Corr',num2str(Correlation),'_','_GridLev', num2str(grid_level), '.mat'];
load(loadfile)

disp([ 'Correlation Correlation Correlation Correlation Correlation Correlation  ' num2str(Correlation)])
disp(['pre process time spent     ' num2str(pre_time_spent/3600) '     hours'])
disp(['number of total inequalities     ' num2str(length(f))])
disp(['number of thetas_checked     ' num2str(number_of_thetas_checked)])
disp(['time spent     ' num2str(time_spent/3600) '     hours'])
disp(['time spent per one theta     ' num2str(time_spent/number_of_thetas_checked) '    secs'])

theta_pass  = THETA_pass;

mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
Zoom_In     = 1e6;
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;

for mm_temp = 1:length(mean_temp)
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp = sort(unique(var_pass));
mean_min = 0*var_temp;
mean_max = 0*var_temp;
for vv_temp = 1:length(var_temp)
    
    mean_min(vv_temp) = min(mean_pass(var_temp(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max(vv_temp) = max(mean_pass(var_temp(vv_temp)==var_pass)); %#ok<*SAGROW>
end
if ii==1
figure(2)
else
h=figure(2);
end

plot([mean_max(1) mean_min mean_max(end)]/Zoom_In*r_bar,[var_temp(1) var_temp var_temp(end)]/Zoom_In*r_bar^2,'Color',[1,.5,0]*ii/length(Kappa_List)+[0,0,1]*(1-ii/length(Kappa_List)),'Linewidth',3)
hold on
plot([mean_min(1) mean_max mean_min(end)]/Zoom_In*r_bar,[var_temp(1) var_temp var_temp(end)]/Zoom_In*r_bar^2,'Color',[1,.5,0]*ii/length(Kappa_List)+[0,0,1]*(1-ii/length(Kappa_List)),'Linewidth',3)
plot([mean_DGP mean_DGP],[0  .25*r_bar^2],'r--', [0 r_bar],[var_DGP var_DGP],'r--','linewidth',.25)
axis([0 r_bar 0 .25*r_bar^2])
mean_pass = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass  = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);

if ii==1
figure(3)
else
h=figure(3);
end
subplot(1,length(Kappa_List),ii) 
plot(mean_pass*r_bar,var_pass*r_bar^2,'color',[ 1 1 1]);
hold on
plot(mean_pass*r_bar,var_pass*r_bar^2,'b.');
plot([mean_DGP mean_DGP],[0  .25*r_bar^2],'r--', [0 r_bar],[var_DGP var_DGP],'r--','linewidth',.25)
axis([0 r_bar 0 .25*r_bar^2])
ax = gca;
ax.XAxis.Exponent = -2;
axis('square')
ylabel('Var$(\nu)$','interpreter','Latex')
xlabel('E$(\nu)$','interpreter','Latex')

if ii==1
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.1*r_bar^2, ['(a) ' '$| \mathcal{D} | = $' num2str(N_menu) ', ' '$\kappa = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',10)        
elseif ii== 2
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.1*r_bar^2, ['(b) ' '$| \mathcal{D} | = $' num2str(N_menu) ', ' '$\kappa = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',10)        
elseif ii== 3
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.1*r_bar^2, ['(c) ' '$| \mathcal{D} | = $' num2str(N_menu) ', ' '$\kappa = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',10)        
end

end
savefig ('./Replication_Figures/Simulations_Figure_1')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Simulations_Figure_1.eps -painters -native

%% Simulations figure 2:
clear variables
close all
N_p_bar         = 100;
N_menu          = 101;
Kappa_List      = [30 70];
Correlation_List= [0 1 2];
grid_level      = 4;

for ii=1:length(Correlation_List)
Correlation     = Correlation_List(ii);
for jj=1:length(Kappa_List)
Kappa           = Kappa_List(jj);
RCL_Kappa       = Kappa;
loadfile = ['.\Replication_Results\Simulations_NbarP',num2str(N_p_bar), '_Nmenu', num2str(N_menu),'_Kappa', num2str(Kappa),'_RCLKappa', num2str(RCL_Kappa),...
               '_Corr',num2str(Correlation),'_','_GridLev', num2str(grid_level), '.mat'];
     
load(loadfile)
disp([ 'Correlation Correlation Correlation Correlation Correlation Correlation  ' num2str(Correlation)])
disp(['pre process time spent     ' num2str(pre_time_spent/3600) '     hours'])
disp(['number of total inequalities     ' num2str(length(f))])
disp(['number of thetas_checked     ' num2str(number_of_thetas_checked)])
disp(['time spent     ' num2str(time_spent/3600) '     hours'])
disp(['time spent per one theta     ' num2str(time_spent/number_of_thetas_checked) '    secs'])

theta_pass  = THETA_pass;

mean_pass   = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass    = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
Zoom_In     = 1e6;
mean_pass   = round(mean_pass*Zoom_In);
var_pass    = round(var_pass*Zoom_In);
mean_pass   = reshape(mean_pass,1,[]);
var_pass    = reshape(var_pass,1,[]);
mean_temp   = sort(unique(mean_pass));
var_min     = 0*mean_temp;
var_max     = 0*mean_temp;

for mm_temp = 1:length(mean_temp)
    var_min(mm_temp) = min(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
    var_max(mm_temp) = max(var_pass(mean_temp(mm_temp)==mean_pass)); %#ok<*SAGROW>
end
var_temp = sort(unique(var_pass));
mean_min = 0*var_temp;
mean_max = 0*var_temp;
for vv_temp = 1:length(var_temp)   
    mean_min(vv_temp) = min(mean_pass(var_temp(vv_temp)==var_pass)); %#ok<*SAGROW>
    mean_max(vv_temp) = max(mean_pass(var_temp(vv_temp)==var_pass)); %#ok<*SAGROW>
end
if ii==1 && jj==1
figure(2)
else
h=figure(2);
end
subplot(1,length(Kappa_List),jj)
plot([mean_max(1) mean_min mean_max(end)]/Zoom_In*r_bar,[var_temp(1) var_temp var_temp(end)]/Zoom_In*r_bar^2,'Color',[1,.5,0]*ii/length(Correlation_List)+[0,0,1]*(1-ii/length(Correlation_List)),'Linewidth',3)
hold on
plot([mean_min(1) mean_max mean_min(end)]/Zoom_In*r_bar,[var_temp(1) var_temp var_temp(end)]/Zoom_In*r_bar^2,'Color',[1,.5,0]*ii/length(Correlation_List)+[0,0,1]*(1-ii/length(Correlation_List)),'Linewidth',3)
plot([mean_DGP mean_DGP],[0  .25*r_bar^2],'r--', [0 r_bar],[var_DGP var_DGP],'r--','linewidth',.25)
axis([0 r_bar 0 .25*r_bar^2])
mean_pass = theta_pass(:,1)./(theta_pass(:,1)+theta_pass(:,2));
var_pass  = theta_pass(:,1).*theta_pass(:,2)./(theta_pass(:,1)+theta_pass(:,2)).^2./(theta_pass(:,1)+theta_pass(:,2)+1);
xlabel('E$(\nu)$','Interpreter','Latex')
ax = gca;
ax.XAxis.Exponent = -2;

if ii==1
figure(3)
else
h=figure(3);
end

subplot(length(Kappa_List),length(Correlation_List),ii+(jj-1)*(length(Correlation_List))) 
plot(mean_pass*r_bar,var_pass*r_bar^2,'b.','MarkerSize',2)
hold on
plot([mean_DGP mean_DGP],[0  .25*r_bar^2],'r--', [0 r_bar],[var_DGP var_DGP],'r--','linewidth',.25)
axis([0 r_bar 0 .25*r_bar^2])
yticks([0 .05*r_bar^2 .1*r_bar^2 .15*r_bar^2 .2*r_bar^2 .25*r_bar^2])
axis square
ylabel('Var$(\nu)$','interpreter','Latex')
xlabel('E$(\nu)$','Interpreter','Latex')
ax = gca;
ax.XAxis.Exponent = -2;

if jj==length(Kappa_List) && ii== 1
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.11*r_bar^2, '(a) No Correlation','Interpreter','Latex','HorizontalAlignment','center','fontsize',9)  
    text(r_bar*.83, .23*r_bar^2, ['$q = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',9)   
elseif jj==length(Kappa_List) && ii== 2
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.11*r_bar^2, '(b) Correlation with $\nu$','Interpreter','Latex','HorizontalAlignment','center','fontsize',9)      
    text(r_bar*.83, .23*r_bar^2, ['$q = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',9)   
elseif jj==length(Kappa_List) && ii== 3
    xlabel('E$(\nu)$','Interpreter','Latex')
    text(r_bar/2, -.11*r_bar^2, '(c) Correlation with $\bar{p}$','Interpreter','Latex','HorizontalAlignment','center','fontsize',9)  
    text(r_bar*.83, .23*r_bar^2, ['$q = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',9)  
else
    text(r_bar*.83, .23*r_bar^2, ['$q = $' num2str(Kappa)],'Interpreter','Latex','HorizontalAlignment','center','fontsize',9)
end
end
end
savefig ('./Replication_Figures/Simulations_Figure_2')
set(gcf, 'Color', 'w');
export_fig ./Replication_Figures/Simulations_Figure_2.eps -painters -native
