function [m_theta,g_ineq,dm_d_theta,f_stdev,G] = full_moments_theta(theta_val,LB_RA_FSTintersect,UB_RA_FSTintersect,LB_RA_FSTintersect_2,UB_RA_FSTintersect_2,ind_type_t_in_j,f,f_b,tau_t,tau_tb,phi_jt,Sample_Size)

delta             = 1e-7;
theta_val_delta_1 = theta_val+[delta 0    ];
theta_val_delta_2 = theta_val+[0     delta];

mtheta_jt         = moments_theta(theta_val,        LB_RA_FSTintersect,UB_RA_FSTintersect,LB_RA_FSTintersect_2,UB_RA_FSTintersect_2,ind_type_t_in_j);
mtheta_jt_1       = moments_theta(theta_val_delta_1,LB_RA_FSTintersect,UB_RA_FSTintersect,LB_RA_FSTintersect_2,UB_RA_FSTintersect_2,ind_type_t_in_j);
mtheta_jt_2       = moments_theta(theta_val_delta_2,LB_RA_FSTintersect,UB_RA_FSTintersect,LB_RA_FSTintersect_2,UB_RA_FSTintersect_2,ind_type_t_in_j);
g_ineq            = -mtheta_jt'*tau_t;
g_ineq_1          = -mtheta_jt_1'*tau_t;
g_ineq_2          = -mtheta_jt_2'*tau_t;

tau_mjt_squared     = (mtheta_jt.^2)'  *tau_t;
tau_mjt_squared_1   = (mtheta_jt_1.^2)'*tau_t;
tau_mjt_squared_2   = (mtheta_jt_2.^2)'*tau_t;
phi_jt_mjt          = sum(phi_jt'.*mtheta_jt  ,1);
phi_jt_mjt_1        = sum(phi_jt'.*mtheta_jt_1,1);
phi_jt_mjt_2        = sum(phi_jt'.*mtheta_jt_2,1);

var                         = (f+tau_mjt_squared  -(2/Sample_Size)*phi_jt_mjt'  ) -(f+g_ineq  ).^2;
var_1                       = (f+tau_mjt_squared_1-(2/Sample_Size)*phi_jt_mjt_1') -(f+g_ineq_1).^2;
var_2                       = (f+tau_mjt_squared_2-(2/Sample_Size)*phi_jt_mjt_2') -(f+g_ineq_2).^2;

var(var<=0)                  = 10^(-12);
var_1(var_1<=0)              = 10^(-12);
var_2(var_2<=0)              = 10^(-12);
 
f_stdev                     = sqrt(var);
f_stdev_1                   = sqrt(var_1);
f_stdev_2                   = sqrt(var_2);

m_theta_0                   = (f + g_ineq  )./f_stdev  ; 
m_theta_1                   = (f + g_ineq_1)./f_stdev_1; 
m_theta_2                   = (f + g_ineq_2)./f_stdev_2; 

m_theta                     = sqrt(Sample_Size)*m_theta_0; 
d_m_d_theta_1               = (m_theta_1-m_theta_0)/delta;
d_m_d_theta_2               = (m_theta_2-m_theta_0)/delta;

dm_d_theta                  = [d_m_d_theta_1 d_m_d_theta_2];

temp                        = -mtheta_jt'*tau_tb;
G                           = (Sample_Size^(.5)./f_stdev).*((f_b+temp)-(f+g_ineq)); 

