function [c_Estep,CV_Estep,max_violation,phi_vec] = get_KMS_critical_value_clean(theta,f,f_keep,f_stdev,G,g_grid,Dg_grid,p_ind,samp_size,KMSoptions)
kappa           = KMSoptions.kappa;
Bn_param        = KMSoptions.bn_param;


dim_p           = size(theta,2);

theta_test  = theta.';
g_ineq      = g_grid;
Dg_ineq     = Dg_grid; 
Dg_ineq     = Dg_ineq./repmat(f_stdev,[1,dim_p]);       

p=[];
if dim_p==2
    if p_ind == 1     % \gamma_1 direction
        p = [ 1 0];
    elseif p_ind == 2   % \gamma_2 direction   
        p = [ 0 1];
    elseif p_ind == 3    % mean(\nu)
        p = [ theta_test(2)./sqrt(theta_test(1).^2+theta_test(2).^2);  -theta_test(1)./sqrt(theta_test(1).^2+theta_test(2).^2)]';
    elseif p_ind == 4    % variance(\nu)
        p1 = theta_test(2).*( -2*theta_test(1).^2 - theta_test(1).*(theta_test(2)+1)                 + theta_test(2).*(  theta_test(2)+1) )./( (theta_test(1)+theta_test(2)).^3*(theta_test(1)+theta_test(2)+1).^2 );
        p2 = theta_test(1).*(    theta_test(1).^2 - theta_test(1).* theta_test(2)    + theta_test(1) - theta_test(2).*(2*theta_test(2)+1) )./( (theta_test(1)+theta_test(2)).^3*(theta_test(1)+theta_test(2)+1).^2 );                                                                                   
        ptemp = [ p1 p2];
        p = ptemp./norm(ptemp);
        check_norm = norm(ptemp)<1e-12;
        if check_norm==1
            disp('Norm of p_vec close to zero')
        end
    end
elseif dim_p==3
   p = [ 0 0 1]; 
end

% GMS
xi                      = (1./kappa)*sqrt(samp_size).*(f + g_ineq)./f_stdev;
phi_test                = KMS_AUX1_phifunc_AS2(xi,Bn_param);  
% Compute critical value
c_Estep          = compute_critical_value_KMS(phi_test,f_keep,G,Dg_ineq,p,dim_p,KMSoptions);

m_theta                 = sqrt(samp_size)*((f + g_ineq)./f_stdev); 
m_theta(f_keep == 0,:)  = [];                                      

CV_Estep          = sum(max(0,m_theta-c_Estep).^2);
max_violation     = max(m_theta - c_Estep);
phi_vec           = phi_test;   
    
end

