function [ theta_grid ,theta_ind] = get_KMS_theta_grid( ind_p_vec, max_direction,theta_AS_grid,r_max,ind_bigger_grid )

% Mean and Variance:
if ind_p_vec==3 || ind_p_vec==4
    mean_var_AS = [ r_max  *theta_AS_grid(:,1)                    ./(  theta_AS_grid(:,1) + theta_AS_grid(:,2)                                                    ) ...
                    r_max^2*theta_AS_grid(:,1).*theta_AS_grid(:,2)./( (theta_AS_grid(:,1) + theta_AS_grid(:,2)).^2.*(theta_AS_grid(:,1) + theta_AS_grid(:,2) + 1) ) ];

                
    AS_mean_95pct       = prctile(mean_var_AS(:,1),95);
    ind_max_mean        = mean_var_AS(:,1)>=AS_mean_95pct;
    theta_max_mean_grid = theta_AS_grid(ind_max_mean==1,:);

    AS_mean_5pct       = prctile(mean_var_AS(:,1),5);
    ind_min_mean        = mean_var_AS(:,1)<=AS_mean_5pct;
    theta_min_mean_grid = theta_AS_grid(ind_min_mean==1,:);

    AS_var_95pct        = prctile(mean_var_AS(:,2),95);
    ind_max_var         = mean_var_AS(:,2)>=AS_var_95pct;
    theta_max_var_grid  = theta_AS_grid(ind_max_var==1,:);

    AS_var_5pct        = prctile(mean_var_AS(:,2),5);
    ind_min_var         = mean_var_AS(:,2)<=AS_var_5pct;
    theta_min_var_grid  = theta_AS_grid(ind_min_var==1,:);
end

if ind_p_vec == 10 || ind_p_vec ==11
    if ind_bigger_grid==0
        AS_ind10_11_95pct           = prctile(theta_AS_grid(:,3),95);
        ind_max_ind10_11            = theta_AS_grid(:,3)>=AS_ind10_11_95pct;
        theta_max_ind10_11_grid     = theta_AS_grid(ind_max_ind10_11==1,:);  
    elseif ind_bigger_grid==1
        AS_ind10_11_95pct           = prctile(theta_AS_grid(:,3),65);
        ind_max_ind10_11            = theta_AS_grid(:,3)>=AS_ind10_11_95pct;
        theta_max_ind10_11_grid     = theta_AS_grid(ind_max_ind10_11==1,:);          
    end
end

if ind_p_vec == 12
    AS_ind12_95pct              = prctile(theta_AS_grid(:,3),5);
    ind_max_ind12               = theta_AS_grid(:,3)<=AS_ind12_95pct;
    theta_max_ind12_grid        = theta_AS_grid(ind_max_ind12==1,:);  
end

% Select Relevant Grid:
if ind_p_vec==3
    if max_direction==1
        theta_grid = theta_max_mean_grid;
        theta_ind  = ind_max_mean;
    else
        theta_grid = theta_min_mean_grid;
        theta_ind  = ind_min_mean;
    end
elseif ind_p_vec==4
    if max_direction==1
        theta_grid = theta_max_var_grid;
        theta_ind  = ind_max_var;
    else
        theta_grid = theta_min_var_grid;
        theta_ind  = ind_min_var;
    end
elseif ind_p_vec==10 || ind_p_vec==11
    theta_grid  = theta_max_ind10_11_grid;
    theta_ind   = ind_max_ind10_11;     
elseif ind_p_vec==12
    theta_grid  = theta_max_ind12_grid;
    theta_ind   = ind_max_ind12;  
end

end

