function [temp_pdfs,Pdf_LB,Pdf_UB] = get_PDF_plot(r_bar,theta_grid,max_cutoff,point_ind)

XX          = [0:.01:1];
epsilon_x   = 10^-07;
XX(1)       = epsilon_x;
XX(end)     = 1 - epsilon_x;
XX_plot     = XX*r_bar;

if size(theta_grid,1)==2 && size(theta_grid,2)==1
    theta_grid = theta_grid';
end

Pdf_temp = zeros(size(theta_grid,1),length(XX));
parfor ii=1:size(theta_grid,1)
   theta_temp       = theta_grid(ii,:);
   Pdf_temp(ii,:)   = betapdf(XX,theta_temp(1),theta_temp(2));  
end

if point_ind==0
    
Pdf_min_max   = zeros(2, length(XX));
for ii=1:length(XX)   
    Pdf_min_max(1,ii) = min(Pdf_temp(:,ii));
    Pdf_min_max(2,ii) = max(Pdf_temp(:,ii));   
end

Pdf_LB    = [XX_plot; Pdf_min_max(1,:)];
Pdf_UB    = [XX_plot; Pdf_min_max(2,:)];

Pdf_LB(2,Pdf_LB(2,:)>max_cutoff) = max_cutoff;
Pdf_UB(2,Pdf_UB(2,:)>max_cutoff) = max_cutoff;

temp_pdfs = Pdf_LB;

else
    Pdf_plot    = [XX_plot; Pdf_temp];
    temp_pdfs = Pdf_plot;
    temp_pdfs(2,temp_pdfs(2,:)>max_cutoff) = max_cutoff;
    temp_pdfs = round(temp_pdfs,15);
    
    Pdf_LB = [];
    Pdf_UB = [];
end

end

