function [f_ineq,f_ineq_keep,N_j,phi_jt] = moments_w(types_choices,types_count_share,map_type_bin,d_sets,deduc_list,bin_size,min_bin_thresh)

zero_thresh     = 2e-5;
num_bins        = max(map_type_bin(:,2));
if num_bins>1
    num_bins=num_bins+1; % aggregate bin
end
Num_d           = size(d_sets,1); 
Size_sets       = size(d_sets,2); 
N_t             = size(map_type_bin,1); 
N_j             = Num_d*num_bins; 
N_i             = sum(types_count_share(:,1)); 

phi_jt          = zeros(N_j,N_t); 

for tt=1:N_t
    temp_choice_count   = types_choices(tt,:);
    bb                  = map_type_bin(tt,2);
    temp_count_set      = zeros(Num_d,1);
    
    for ds=1:Num_d 
        sum_ind_mat = 0;
        for xx=1:Size_sets 
           temp_ded         = d_sets(ds,xx);
           temp_ind         = double(deduc_list==temp_ded);
           
           temp_choice_mat  = temp_choice_count*temp_ind';
           sum_ind_mat      = sum_ind_mat + temp_choice_mat;         
        end 
        temp_count_set(ds) = sum_ind_mat;
    end   
    phi_jt((bb-1)*Num_d+1:bb*Num_d,tt)    = temp_count_set;
    phi_jt(end-Num_d+1:end,tt)            = temp_count_set;
end
f_ineq = sum(phi_jt,2)./N_i; 

constraint_bin_size = repmat(bin_size,1,Num_d)';
constraint_bin_size = constraint_bin_size(:);
constraint_bin_size = [constraint_bin_size; ones(Num_d,1)*N_i];

ind_zero_prob       = f_ineq<=zero_thresh;
f_ineq_keep         = (constraint_bin_size>=min_bin_thresh).*(1-ind_zero_prob);

end

