function [theta_grid_refined] = refine_AS_grid_dim3(theta_orig,ind_pi,beta_alpha_range,beta_beta_range,ind_younglow)

if ind_pi==1
    ind_1               = max(theta_orig(:,3));
    ind_2               = max(theta_orig(theta_orig(:,3)<max(theta_orig(:,3)),3));
    if isempty(ind_2) 
        ind_2           = max(ind_1-.05,0)+.01;
    end
    pi_supp_range       = ((ind_2):.01:(ind_1+.1));
    theta_pass_test1    = theta_orig(theta_orig(:,3)==ind_1,:);
    theta_pass_test2    = theta_orig(theta_orig(:,3)==ind_2,:);
    theta_pass_test     = [theta_pass_test1; theta_pass_test2];
elseif ind_pi==2
    ind_1               = max(theta_orig(:,3));
    ind_2               = max(theta_orig(theta_orig(:,3)<max(theta_orig(:,3)),3));
    if isempty(ind_2)
        ind_2           = ind_1-.1;
    end
    pi_supp_range       = ((ind_2):.01:min((ind_1+.2),1));
    theta_pass_test1    = theta_orig(theta_orig(:,3)==ind_1,:);
    theta_pass_test2    = theta_orig(theta_orig(:,3)==ind_2,:);
    theta_pass_test     = [theta_pass_test1; theta_pass_test2];
elseif ind_pi==3
    ind_1               = min(theta_orig(:,3));
    ind_2               = min(theta_orig(theta_orig(:,3)>min(theta_orig(:,3)),3));
        if ind_1==.2
            pi_3_supp_range       = (min(theta_orig(:,3))-.19):.01:(min(theta_orig(:,3)+.1));
        else
            pi_3_supp_range       = (max(min(theta_orig(:,3))-.09,0)):.01:(min(theta_orig(:,3)+.1));
        end
    theta_pass_test1    = theta_orig(theta_orig(:,3)==ind_1,:);
    if isempty(ind_2)==0
    theta_pass_test2    = theta_orig(theta_orig(:,3)==ind_2,:);
    else
        theta_pass_test2 = [];
    end
    pi_supp_range       = [0 pi_3_supp_range];
    theta_pass_test     = [theta_pass_test1; theta_pass_test2];
end

if ind_younglow==0
    small_step_alpha = .05;
    small_step_beta  = .05;
elseif ind_younglow==1
    small_step_alpha = .25;
    small_step_beta  = .25; 
end

theta_refine_add = [];
parfor tt=1:size(theta_pass_test,1)
    temp_theta = theta_pass_test(tt,:);
    ind_alpha = find(beta_alpha_range==temp_theta(1));
    ind_beta  = find( beta_beta_range==temp_theta(2)); 
    add = [];
    if ind_alpha<length(beta_alpha_range) && ind_beta<length(beta_beta_range) % neither param is the max value
        if ind_alpha>1 && ind_beta>1 % interior in the grid
            add1 = [temp_theta(1) beta_beta_range(ind_beta-1)]; % add one to right and left on second param
            add2 = [temp_theta(1) beta_beta_range(ind_beta+1)];
            add3 = [beta_alpha_range(ind_alpha-1) temp_theta(2)]; % add one to right and left on first param
            add4 = [beta_alpha_range(ind_alpha+1) temp_theta(2)];
            add5 = [beta_alpha_range(ind_alpha-1) beta_beta_range(ind_beta-1)]; % add both to right and left
            add6 = [beta_alpha_range(ind_alpha-1) beta_beta_range(ind_beta+1)];
            add7 = [beta_alpha_range(ind_alpha+1) beta_beta_range(ind_beta-1)];
            add8 = [beta_alpha_range(ind_alpha+1) beta_beta_range(ind_beta+1)];

            add = [add1; add2; add3; add4; add5; add6; add7; add8];     
        elseif ind_alpha>1 
            add2 = [temp_theta(1) beta_beta_range(ind_beta+1)];
            add3 = [beta_alpha_range(ind_alpha-1) temp_theta(2)];
            add4 = [beta_alpha_range(ind_alpha+1) temp_theta(2)];
            add6 = [beta_alpha_range(ind_alpha-1) beta_beta_range(ind_beta+1)];
            add8 = [beta_alpha_range(ind_alpha+1) beta_beta_range(ind_beta+1)];

            add = [add2; add3; add4; add6; add8];
        elseif ind_beta>1
            add1 = [temp_theta(1) beta_beta_range(ind_beta-1)];
            add2 = [temp_theta(1) beta_beta_range(ind_beta+1)];
            add4 = [beta_alpha_range(ind_alpha+1) temp_theta(2)];
            add7 = [beta_alpha_range(ind_alpha+1) beta_beta_range(ind_beta-1)];
            add8 = [beta_alpha_range(ind_alpha+1) beta_beta_range(ind_beta+1)];

            add = [add1; add2; add4; add7; add8];      
        end   
    elseif ind_alpha<length(beta_alpha_range)
        disp('UB on beta grid')
    elseif ind_beta<length(beta_beta_range)
        disp('UB on alpha grid')
    else
        disp('UB on both dimensions of parameter grid')
    end
    theta_refine_add = [theta_refine_add; add];  
end

theta_refine = [theta_pass_test(:,1:2); theta_refine_add];
theta_refine = unique(theta_refine,'rows');
     
refine_alpha_vals = unique(theta_refine(:,1));
add_small_steps1 = [];
parfor  aa=1:length(refine_alpha_vals)
   temp_alpha = refine_alpha_vals(aa);
   temp_thetas = theta_refine(theta_refine(:,1)==temp_alpha,:); %#ok<PFBNS>
   
   temp_beta_min = min(temp_thetas(:,2));
   temp_beta_max = max(temp_thetas(:,2));
   
   temp_new_beta = temp_beta_min:small_step_beta:temp_beta_max;
   
   add_small_steps1 = [add_small_steps1; [repmat(temp_alpha,length(temp_new_beta),1) temp_new_beta']];
end    
theta_grid_refined1 = [theta_refine; add_small_steps1];
theta_grid_refined1 = unique(theta_grid_refined1,'rows');

refine_beta_vals  = unique(theta_grid_refined1(:,2));

add_small_steps2 = [];
parfor  bb=1:length(refine_beta_vals)
   temp_beta = refine_beta_vals(bb);
   temp_thetas = theta_grid_refined1(theta_grid_refined1(:,2)==temp_beta,:); %#ok<PFBNS>
   
   temp_alpha_min = min(temp_thetas(:,1));
   temp_alpha_max = max(temp_thetas(:,1));
   
   temp_new_alpha = temp_alpha_min:small_step_alpha:temp_alpha_max;
   
   add_small_steps2 = [add_small_steps2; [temp_new_alpha' repmat(temp_beta,length(temp_new_alpha),1) ]];
end 
theta_grid_refined_2 = [theta_grid_refined1; add_small_steps2];
theta_grid_refined_2 = unique(theta_grid_refined_2,'rows');

theta_grid_refined        = zeros(size(theta_grid_refined_2,1)*length(pi_supp_range),3);
theta_grid_refined(:,1:2) = repmat(theta_grid_refined_2,     length(pi_supp_range)  ,1);
temp                      = repmat(       pi_supp_range,size(theta_grid_refined_2,1),1);
theta_grid_refined(:,3)   = temp(:);

theta_grid_refined = [theta_grid_refined; theta_orig];
    
theta_grid_refined = unique(theta_grid_refined,'rows');


end

