function [psi_1] = test_coverage(c_1,psi_0,psi_2,phi_test,f_keep,G,D,p,dim_p,KMSoptions)

rho         = KMSoptions.rho;
type        = KMSoptions.type;
CVX_maxit   = KMSoptions.CVX_maxit;
S           = 0;

J               = length(f_keep);
psi_1 = -999*ones(size(psi_0));  


psi_1( psi_0 == psi_2 & psi_0 == 0,1) = 0;
psi_1( psi_0 == psi_2 & psi_0 == 1,1) = 1;

ind_psi = find(psi_1 == -999);
d_ind = size(ind_psi,1);

%% CVXGEN or CVX
A = zeros(J + 2*dim_p + 2 + S,dim_p);
b = zeros(J + 2*dim_p + 2 + S,1);

ind_phi = find(phi_test > -inf & f_keep == 1);
A(ind_phi,:) = D(ind_phi,:);

A(J+1:J+dim_p,:)            = eye(dim_p,dim_p);
A(J+dim_p + 1:J+2*dim_p,:)  = -eye(dim_p,dim_p);
b(J+1:J+dim_p,1)            = rho;
b(J+dim_p + 1:J+2*dim_p,1)  = rho;

if strcmp('two-sided',type) == 1
    A(J+2*dim_p+1,:) = -p;
    A(J+2*dim_p+2,:) = p;
    b(J+2*dim_p+1,:) = 0;
    b(J+2*dim_p+2,:) = 0;
elseif strcmp('one-sided-UB',type) == 1
    A(J+2*dim_p+1,:) = -p;
    b(J+2*dim_p+1,:) = 0;
elseif strcmp('one-sided-LB',type) == 1
    A(J+2*dim_p+2,:) = p;
    b(J+2*dim_p+2,:) = 0;
end

for ii = 1:d_ind
    b(ind_phi,1)        = c_1-G(ind_phi,ind_psi(ii))-phi_test(ind_phi,1); 

    params.A            = A;
    params.b            = b;
    settings.verbose    = 0;                                                     
    settings.eps        = 1e-9;   
    settings.max_iters  = CVX_maxit;
   
    ind_drop = find(phi_test == -inf | f_keep == 0);
    A_cvx = A;
    b_cvx = b;
    A_cvx(ind_drop,:) = [];
    b_cvx(ind_drop,:) = [];
    
    temp_Jsize = length(b_cvx);
    if dim_p==2
        if temp_Jsize <=356
            A_cvxgen = [A_cvx(1:end-2,:); zeros(356-temp_Jsize,dim_p); A_cvx(end-1:end,:)];
            b_cvxgen = [b_cvx(1:end-2,:); zeros(356-temp_Jsize,1);     b_cvx(end-1:end,:)];
            params.A = A_cvxgen;
            params.b = b_cvxgen;
            [~,status] = csolve_356_2(params,settings);
        else 
            % cvx_solver mosek
            warning('off','MATLAB:nargchk:deprecated')
            disp('cvx')
            cvx_begin quiet
                variable lambda(dim_p, 1);
                minimize(0);
                subject to
                A_cvx*lambda <= b_cvx;
            cvx_end
            status.converged    = strcmp(cvx_status, 'Solved');
        end

    elseif dim_p ==3
        if temp_Jsize <=358
            A_cvxgen = [A_cvx(1:end-2,:); zeros(358-temp_Jsize,dim_p); A_cvx(end-1:end,:)];
            b_cvxgen = [b_cvx(1:end-2,:); zeros(358-temp_Jsize,1);     b_cvx(end-1:end,:)];
            params.A = A_cvxgen;
            params.b = b_cvxgen;
            [~,status] = csolve_358_3(params,settings);
        else 
            % cvx_solver mosek
            warning('off','MATLAB:nargchk:deprecated')
            disp('cvx')

            cvx_begin quiet
                variable lambda(dim_p, 1);
                minimize(0);
                subject to
                A_cvx*lambda <= b_cvx;
            cvx_end
            status.converged    = strcmp(cvx_status, 'Solved');
        end
    end

    if status.converged==1  
        psi_1(ind_psi(ii)) = 1;
    else
        psi_1(ind_psi(ii)) = 0;
    end
end

end












